package ca.mcgill.sel.aspectoptima.aspects.accessclassified;

import java.lang.reflect.Method;
import java.util.Map;
import java.util.HashMap;

public interface AccessClassified {
	// public method signatures from structural view
	AccessKind getAccessKind(Method m);
}

aspect AccessClassifiedAspect {
	// bind annotations to mandatory instantiation parameters
	
	// attributes & associations from structural view
	// empty
	// BEGIN implementation refinement
	/** if AspectJ would support the inter-type declaration of static fields on interfaces 
	this map would be static and introduced via an implementation of the interface
    as this is not possible this map is redundant in every object of the AccessClassified class
    TODO find solution without redundancy (per target aspect or something like this) */
	public Map<Method, AccessKind> AccessClassified.methodToAccessKindMap = new HashMap<Method, AccessKind>();
	
	/** initialises a mapping from every declared method to its accessKind */
	after(): initialization(AccessClassified+.new(..)) {
		for(Method method : thisJoinPoint.getSignature().getDeclaringType().getDeclaredMethods()) {
			AccessClassifiedMethod methodAnnotation = method.getAnnotation(AccessClassifiedMethod.class);
			if (methodAnnotation != null) {
				AccessKind accessKind = methodAnnotation.value();
				AccessClassified accessClassifiedObject = (AccessClassified) thisJoinPoint.getThis();
				accessClassifiedObject.methodToAccessKindMap.put(method, accessKind);
			}
		}
	}
	// END implementation refinement
	
	// declared methods without message views
	public AccessKind AccessClassified.getAccessKind(Method m) {
		// BEGIN implementation refinement
		return methodToAccessKindMap.get(m);
		// END implementation refinement
	}

	// methods shown in message views
	// empty
}
