package ca.mcgill.sel.aspectoptima.aspects.checkpointable;


import java.util.Stack;
import ca.mcgill.sel.aspectoptima.aspects.copyable.Copyable;

public interface Checkpointable extends Copyable {
	// public method signatures from structural view
	void establishNewCheckpoint();
	void restoreLastCheckpoint();
	void discardLastCheckpoint();
}

aspect CheckpointableAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @CheckpointableClass * implements Checkpointable;
	
	// attributes & associations from structural view
	private Stack<Checkpointable> Checkpointable.checkpoints = new Stack<Checkpointable>();
	
	// declared methods without message views
	// empty

	// methods shown in message views
	public void Checkpointable.establishNewCheckpoint() {
		Checkpointable newCheckpoint = (Checkpointable) this.copy();
		this.checkpoints.push(newCheckpoint);
	}
	
	public void Checkpointable.restoreLastCheckpoint() {
		/* FIXME throw exception if this.checkpoints.size < 1 */
		Checkpointable last = this.checkpoints.pop();
		this.replaceStateWith(last);
	}
	
	public void Checkpointable.discardLastCheckpoint() {
		/* FIXME throw exception if this.checkpoints.size < 1 */
		this.checkpoints.pop();
	}
}
