package ca.mcgill.sel.aspectoptima.aspects.checkpointing;

import org.aspectj.lang.annotation.AdviceName;

import ca.mcgill.sel.aspectoptima.aspects.checkpointable.Checkpointable;
import ca.mcgill.sel.aspectoptima.aspects.tracing.Traced;
import ca.mcgill.sel.aspectoptima.interfacing.ParticipantPool;

public interface Checkpointed extends Checkpointable, Traced {
	// public method signatures from structural view
	// empty
}

aspect CheckpointedAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @CheckpointedClass * implements Checkpointed;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	/** creates a Checkpoint for the target if it was not accessed before */
	@AdviceName("checkpointMethod")
	before(Checkpointed target): execution(@CheckpointedMethod * *.*(..)) && target(target) {
		CheckpointingParticipant participant = (CheckpointingParticipant) CheckpointingParticipantStatic.getCurrent();
		CheckpointingContext context = (CheckpointingContext) participant.getContext();
		/* check whether it is the first access to this target */
		boolean secondTime = context.wasAccessed(target);
		if (!secondTime) {
			target.establishNewCheckpoint();
		}
	}
}
