package ca.mcgill.sel.aspectoptima.aspects.checkpointing;

import java.util.HashSet;
import java.util.Set;

import ca.mcgill.sel.aspectoptima.aspects.tracing.Traced;
import ca.mcgill.sel.aspectoptima.aspects.tracing.TracingContext;

public interface CheckpointingContext extends TracingContext {
	// public method signatures from structural view
	void restoreCheckpoints();
	void discardCheckpoints();
}

aspect CheckpointingContextAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	public void CheckpointingContext.restoreCheckpoints() {
		/* FIXME throw exception if state != completed */
		Set<Traced> accessed = this.getAccessed();
		Set<Traced> toBeRemoved = new HashSet<Traced>();
		for (Traced t: accessed) {
			((Checkpointed) t).restoreLastCheckpoint();
			toBeRemoved.add(t);
		}
		this.removeTraces(toBeRemoved);
	}	
	
	public void CheckpointingContext.discardCheckpoints() {
		Set<Traced> accessed = this.getAccessed();
		Set<Traced> toBeRemoved = new HashSet<Traced>();
		for (Traced t : accessed) {
			((Checkpointed) t).discardLastCheckpoint();
			toBeRemoved.add(t);
		}				
		this.removeTraces(toBeRemoved);
	}
}
