package ca.mcgill.sel.aspectoptima.aspects.context;

import java.lang.reflect.Constructor;

import org.aspectj.lang.reflect.MethodSignature;

import ca.mcgill.sel.aspectoptima.interfacing.ParticipantPool;


public interface Participant {
	// public method signatures from structural view
	Context getContext();
	void setContext(Context context);
	void createAndEnterContext();
	void enterContext(Context c);
	void leaveContext();
}

aspect ParticipantAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @ParticipantClass * implements Participant;
	
	// attributes & associations from structural view
	private Context Participant.context;
	
	// declared methods without message views
	public Context Participant.getContext() {
		// auto-generated getter implementation
		return this.context;
	}
	
	public void Participant.setContext(Context context) {
		// auto-generated setter implementation
		this.context = context;
	}
	
	Context Participant.createContext() {
		/* FIXME implement introduced method-stub */
		return null;
	}

	// methods shown in message views
	public void Participant.createAndEnterContext() {
		Context newContext = (Context) createContext();
		this.enterContext(newContext);
	}
	
	public void Participant.enterContext(Context c) {
		System.out.flush();
		c.addParticipant(this);
		System.out.flush();
		this.setContext(c);
	}
	
	public void Participant.leaveContext() {
		Context myContext = this.getContext();
		// BEGIN implementation refinement
		if (myContext != null) {
		// END implementation refinement
			/* FIXME throw exception if myContext == null */
			myContext.removeParticipant(this);
			this.setContext(null);
			myContext.contextCompleted();
		// BEGIN implementation refinement
		}
		// END implementation refinement
	}
	
	// BEGIN implementation refinement
	@SuppressWarnings("unchecked")
	Context around(Participant participant) : execution(Context Participant.createContext()) && target(participant) {
		try {
			String participantClassName = participant.getClass().getName();
			String contextImplClassName = participantClassName.replaceFirst("Participant", "Context");
			Class<? extends Context> implementationClass = (Class<? extends Context> ) Class.forName(contextImplClassName);
			Constructor<? extends Context> constructor = implementationClass.getDeclaredConstructor((Class<?>[]) null);
			constructor.setAccessible(true);
			return constructor.newInstance((Object[]) null);
		} catch (Exception e) {
			// swallow
			e.printStackTrace();
		}
		return null;
	}
	
	Participant around(Object t) : call(Participant ParticipantStatic.getCurrent()) && this(t){
		try {
			String aspectName = t.getClass().getName();
			/* ATTENTION "DIRTY" HACK */
			String participantClassName = aspectName.replaceFirst("edAspect", "ingParticipant");
			Class<? extends Participant> participantClass = (Class<? extends Participant> ) Class.forName(participantClassName);
			return ParticipantPool.getParticipant(participantClass);
		} catch (Exception e) {
			/* swallow */
			e.printStackTrace();
		}
		return null;
	}
	// END implementation refinement
}
