package ca.mcgill.sel.aspectoptima.aspects.copyable;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as Copyable for the AspectOPTIMA Framework. <br>
 * Copyable objects need to be Serializable and thus they may only
 * contain fields of types that implement the interface java.io.Serializable. <br>
 * Automatically declares that the object implements the interface java.io.Serializable.
 * @see java.io.Serializable
 */
@Target( { ElementType.TYPE })
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface CopyableClass {
	// empty
}