package ca.mcgill.sel.aspectoptima.aspects.deferrable;

import java.lang.annotation.Documented;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;
import java.lang.annotation.ElementType;

/**
 * Marks a method as Deferrable for the AspectOPTIMA Framework<br>
 * Objects containing Deferrable methods should be annotated with @DeferrableClass.
 */
@Target( { ElementType.METHOD })
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface DeferrableMethod {
	// empty
}