package ca.mcgill.sel.aspectoptima.aspects.deferring;

import java.util.Collection;

import ca.mcgill.sel.aspectoptima.aspects.deferrable.Deferrable;
import ca.mcgill.sel.aspectoptima.aspects.tracing.Traced;
import ca.mcgill.sel.aspectoptima.aspects.tracing.TracingContext;

public interface DeferringContext extends TracingContext {
	// public method signatures from structural view
	/** performs the updates made by the participant of the DeferringContext by retrieving all accessed Objects and updating each */
	void performUpdate();
}

aspect DeferringContextAspect {
	// attributes & associations from structural view
	// empty

	// declared methods without message views
	// empty

	// methods shown in message views
	public void DeferringContext.performUpdate() {
		Collection<Traced> traced = getAccessed();
		for (Traced t : traced) {
			/* FIXME throw exception if traced !instanceof Deferrable */
			((Deferrable) t).updateOriginal(this);
		}
	}
}
