package ca.mcgill.sel.aspectoptima.aspects.nested;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.Collection;
import java.util.Set;

import org.aspectj.lang.SoftException;
import org.aspectj.lang.annotation.AdviceName;
import org.aspectj.lang.reflect.MethodSignature;


public abstract aspect NestedContextAddChildrensResultsAspect<T extends Collection<?>> {
	public abstract pointcut m(NestedContext target);
	
	@AdviceName("addChildrensResults")
	T around(NestedContext target) : m(target) {
		T result = null;
		try {
			result = proceed(target);
			Set<NestedContext> children = target.getChildren();
			for (NestedContext c : children) {
				Method m = ((MethodSignature) thisJoinPointStaticPart.getSignature()).getMethod();
				T childResult = (T) m.invoke(c, (Object[]) null);
				result.addAll(childResult);
			}
		} catch (Exception e) {
			if (e instanceof InvocationTargetException)
			    throw new SoftException(e);
			// swallow reflection exceptions
			e.printStackTrace();
		}
		return result;
	}
}
