package ca.mcgill.sel.aspectoptima.aspects.nested;

import ca.mcgill.sel.aspectoptima.aspects.context.Participant;
import ca.mcgill.sel.aspectoptima.aspects.context.Context;

public interface NestedParticipant extends Participant {
	// public method signatures from structural view
	// empty
}

aspect NestedParticipantAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @NestedParticipantClass * implements NestedParticipant;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	void around(NestedParticipant participant, NestedContext context) : execution(void Participant.enterContext(..)) && target(participant) && args(context) {
		NestedContext oldContext = (NestedContext) participant.getContext();
		proceed(participant, context);
		if (oldContext != null) {
			NestedContext newContext = (NestedContext) participant.getContext();
			/* FIXME throw exception if newContext == null */
			if (newContext != null) {
				oldContext.addChild(newContext);
				newContext.setParent(oldContext);
			}
		}
	}
	
	void around(NestedParticipant participant) : execution(void Participant.leaveContext()) && target(participant) {
		NestedContext oldContext = (NestedContext) participant.getContext();
		NestedContext parentContext = oldContext.getParent();
		proceed(participant);
		if (parentContext != null) {
			participant.setContext(parentContext);
		}
	}
}
