package ca.mcgill.sel.aspectoptima.aspects.recovering;

import ca.mcgill.sel.aspectoptima.aspects.checkpointing.CheckpointingContext;
import ca.mcgill.sel.aspectoptima.aspects.outcomeaware.Outcome;
import ca.mcgill.sel.aspectoptima.aspects.context.Context;

public interface RecoveringContextCheckpointing extends RecoveringContext, CheckpointingContext {
	// public method signatures from structural view
	// empty
}

aspect RecoveringContextCheckpointingAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	before(RecoveringContextCheckpointing context) : execution(void Context.contextCompleted()) && target(context) {
		Outcome outcome = context.getOutcome();
		/* FIXME throw exception if outcome == null */
		boolean failed = true;
		if (outcome != null) {
			failed = !outcome.isPositive();
		}
		if (failed) {
			context.restoreCheckpoints();
		} else {
			context.discardCheckpoints();
		}
	}
}

