package ca.mcgill.sel.aspectoptima.aspects.traceable;

import java.lang.reflect.Method;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;

public interface Trace {
	// public method signatures from structural view
	Traceable getTarget();
	public AccessKind getAccessKind();
}

aspect TraceAspect {
	// attributes & associations from structural view
	private Method Trace.method;
	private AccessKind Trace.accessKind;
	private Traceable Trace.target;

	// declared methods without message views
	public Traceable Trace.getTarget() {
		// auto-generated getter implementation
		return this.target;
	}
	
	public AccessKind Trace.getAccessKind() {
		// auto-generated getter implementation
		return this.accessKind;
	}
	
	TraceImpl.new(Method method, AccessKind accessKind, Traceable target) {
		// auto-generated constructor using fields
		this();
		this.method = method;
		this.accessKind = accessKind;
		this.target = target;
	}
	
	// methods shown in message views
	// empty
}