package ca.mcgill.sel.aspectoptima.aspects.traceable;

import java.lang.reflect.Method;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessClassified;

public interface Traceable extends AccessClassified {
	// public method signatures from structural view
	/** creates and returns a Trace containing the method, its AccessKind and the target */
	Trace createTrace(Method method);
}

aspect TraceableAspect {
	// bind annotations to mandatory instantiation parameters
	declare parents : @TraceableClass * implements Traceable;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	public Trace Traceable.createTrace(Method m) {
		AccessKind accessKind = this.getAccessKind(m);
		return new TraceImpl(m, accessKind, this);
	}
}
