package ca.mcgill.sel.aspectoptima.aspects.traceable;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as Traceable for the AspectOPTIMA Framework. <br>
 * Methods of Traceable objects can be marked as Traceable using @TraceableMethod.
 */
@Target({ElementType.TYPE}) 
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface TraceableClass {
	// empty
}