package ca.mcgill.sel.aspectoptima.aspects.tracing;

import java.lang.annotation.Documented;
import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * Marks an object as Traced for the AspectOPTIMA Framework. <br>
 * The needed Annotation @TraceableClass is added automatically. <br>
 * Methods of Traced objects can be marked as Traced using @TracedMethod. <br>
 */
@Target({ElementType.TYPE}) 
@Documented
@Retention(RetentionPolicy.RUNTIME)
public @interface TracedClass {
	// empty
}
