package ca.mcgill.sel.aspectoptima.example.banking;

import java.io.Serializable;

import ca.mcgill.sel.aspectoptima.aspects.transaction.ConcurrencyControl;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactableClass;
import ca.mcgill.sel.aspectoptima.example.banking.exception.InsufficientFoundsException;
import ca.mcgill.sel.aspectoptima.interfacing.AutoTransactedClass;

@AutoTransactedClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING, nested = false)
//TODO !!!!!! REMOVE THIS ONCE WILDCARDS AND PARAMS ARE ALLOWED
@TransactableClass(updateStrategy = UpdateStrategy.DEFERRING, concurrencyControl = ConcurrencyControl.TWOPHASELOCKING)
public class Account implements Serializable {
	private int id;
	private float balance;
	private float limit;

	public Account() {
		/* needed for java.io.Serializable */
	}

	protected Account(int id, float balance, float limit) {
		this.id = id;
		this.balance = balance;
		this.limit = limit;
	}

	protected int getId() {
		return this.id;
	}

	protected float getBalance() {
		return this.balance;
	}

	protected void withdraw(float amount) throws InsufficientFoundsException {
		if (this.balance - amount < limit) {
			throw new InsufficientFoundsException();
		}
		this.balance -= amount;
	}

	protected void deposit(float amount) {
		this.balance += amount;
	}
}
