package ca.mcgill.sel.aspectoptima.test;

import ca.mcgill.sel.aspectoptima.aspects.checkpointing.CheckpointingParticipant;
import ca.mcgill.sel.aspectoptima.aspects.deferring.DeferringContext;
import ca.mcgill.sel.aspectoptima.aspects.deferring.DeferringParticipant;
import ca.mcgill.sel.aspectoptima.aspects.nested.NestedParticipant;
import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoveringParticipantCheckpointing;
import ca.mcgill.sel.aspectoptima.aspects.recovering.RecoveringParticipantDeferring;
import ca.mcgill.sel.aspectoptima.aspects.tracing.TracingParticipant;
import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactionParticipantCheckpointingTwoPhaseLocking;
import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactionParticipantCheckpointingTwoPhaseLockingNested;
import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactionParticipantDeferringTwoPhaseLocking;
import ca.mcgill.sel.aspectoptima.aspects.transaction.TransactionParticipantDeferringTwoPhaseLockingNested;
import ca.mcgill.sel.aspectoptima.aspects.twophaselocking.TwoPhaseLockingParticipant;
import ca.mcgill.sel.aspectoptima.interfacing.ParticipantPool;

public class AspectOPTIMATesting {

	public static void begin2PL() {
		ParticipantPool.begin(TwoPhaseLockingParticipant.class);
	}

	public static void beginCheckpointing() {
		ParticipantPool.begin(CheckpointingParticipant.class);
	}

	public static void beginDeferring() {
		ParticipantPool.begin(DeferringParticipant.class);
	}

	public static void beginNested() {
		ParticipantPool.begin(NestedParticipant.class);
	}

	public static void beginRecoveringCheckpointing() {
		ParticipantPool.begin(RecoveringParticipantCheckpointing.class);
	}

	public static void beginRecoveringDeferring() {
		ParticipantPool.begin(RecoveringParticipantDeferring.class);
	}

	public static void beginTracing() {
		ParticipantPool.begin(TracingParticipant.class);
	}

	public static void end() {
		ParticipantPool.end();
	}

	public static void performUpdate() {
		DeferringParticipant participant = (DeferringParticipant) ParticipantPool
				.claimParticipant();
		DeferringContext context = (DeferringContext) participant.getContext();
		context.performUpdate();
	}
	
	public static void abort() {
		ParticipantPool.abort();
	}

	public static void beginCheckpointed2PLTransaction() {
		 ParticipantPool.begin(TransactionParticipantCheckpointingTwoPhaseLocking.class);
	}

	public static void beginDeferred2PLTransaction() {
		 ParticipantPool.begin(TransactionParticipantDeferringTwoPhaseLocking.class);
	}

	public static void beginDeferredOVTransaction() {
		// ParticipantPool.begin(TransactionDeferringOVParticipant.class);
	}

	public static void commit() {
		ParticipantPool.commit();
	}
	
	public static void beginCheckpointed2PLNestedTransaction() {
		 ParticipantPool.begin(TransactionParticipantCheckpointingTwoPhaseLockingNested.class);
	}
	
	public static void beginDeferred2PLNestedTransaction() {
		 ParticipantPool.begin(TransactionParticipantDeferringTwoPhaseLockingNested.class);
	}
}
