package ca.mcgill.sel.aspectoptima.test;

import org.junit.Test;
import static org.junit.Assert.*;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.checkpointing.*;

@CheckpointedClass
public class CheckpointingTest {
	int insideTest = 0;
	
	@Test
	public void test() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.beginCheckpointing();
		CheckpointingTest test = new CheckpointingTest();
		test.foo(1);
		test.bar(4,5);
		assertEquals(4, test.insideTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.end();
		assertEquals(4, test.insideTest);
	}
	
	@CheckpointedMethod(AccessKind.READ)
	void foo(int a) {
		insideTest = a;
		bar(2,3);
	}
	
	@CheckpointedMethod(AccessKind.READ)
	void bar(int a, int b) {
		insideTest = a;
	}
}
