package ca.mcgill.sel.aspectoptima.test;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.recovering.*;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;

@RecoverableClass(UpdateStrategy.CHECKPOINTING)
public class RecoveringTest {
	int insideTest = 0;

	@Test
	public void recoveringCheckpointingAbortTest() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting
				.beginRecoveringCheckpointing();
		RecoveringTest test = new RecoveringTest();
		test.foo(1);
		test.bar(4, 5);
		assertEquals(4, test.insideTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.abort();
		assertEquals(0, test.insideTest);
	}

	@RecoverableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING)
	void foo(int a) {
		insideTest = a;
		bar(2, 3);
	}

	@RecoverableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.CHECKPOINTING)
	void bar(int a, int b) {
		insideTest = a;
	}

	@Test
	public void recoveringCheckpointingCommitTest() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting
				.beginRecoveringCheckpointing();
		RecoveringTest test = new RecoveringTest();
		test.foo(1);
		test.bar(4, 5);
		assertEquals(4, test.insideTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.commit();
		assertEquals(4, test.insideTest);
	}
}