package ca.mcgill.sel.aspectoptima.test;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.recovering.UpdateStrategy;
import ca.mcgill.sel.aspectoptima.aspects.recovering.*;

@RecoverableClass(UpdateStrategy.DEFERRING)
public class RecoveringTestDeferring {
	int insideTest = 0;
	
	@Test
	public void recoveringDeferringAbortTest() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting
				.beginRecoveringDeferring();
		RecoveringTestDeferring test = new RecoveringTestDeferring();
		test.foo2(1);
		test.bar2(4, 5);
		assertEquals(0, test.insideTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.abort();
		assertEquals(0, test.insideTest);
	}

	@RecoverableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING)
	void foo2(int a) {
		insideTest = a;
		bar2(2, 3);
	}

	@RecoverableMethod(accessKind = AccessKind.READ, updateStrategy = UpdateStrategy.DEFERRING)
	void bar2(int a, int b) {
		insideTest = a;
	}
	
	@Test
	public void recoveringDeferringCommitTest() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting
				.beginRecoveringDeferring();
		RecoveringTestDeferring test = new RecoveringTestDeferring();
		test.foo2(1);
		test.bar2(4, 5);
		assertEquals(0, test.insideTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.commit();
		assertEquals(4, test.insideTest);
	}
}

