package ca.mcgill.sel.aspectoptima.test;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

import ca.mcgill.sel.aspectoptima.aspects.accessclassified.AccessKind;
import ca.mcgill.sel.aspectoptima.aspects.twophaselocking.*;

@TwoPhaseLockedClass
public class TwoPhaseLockingTest {
	int insideTest = 0;
	
	@Test
	public void TwoPhaseLockingTest() {
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.begin2PL();
		TwoPhaseLockingTest test = new TwoPhaseLockingTest();
		test.foo(1);
		test.bar(4,5);
		assertEquals(4, test.insideTest);
		ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting.end();
		assertEquals(4, test.insideTest);
	}
	
	@TwoPhaseLockedMethod(AccessKind.READ)
	void foo(int a) {
		insideTest = a;
		bar(2,3);
	}
	
	@TwoPhaseLockedMethod(AccessKind.READ)
	void bar(int a, int b) {
		insideTest = a;
	}
}
