package ca.mcgill.sel.aspectoptimaomtt.aspects.blockable;

import java.lang.reflect.Method;
import java.util.Map;
import java.util.concurrent.Semaphore;

import ca.mcgill.sel.aspectoptima.aspects.context.Participant;

public interface BlockableParticipant extends Participant {
	// empty to allow multiple binding
}

class BlockableParticipantMessages {
	// static version of methods shown in message views
	static void waitForSemaphore(BlockableParticipant blockableParticipant, Map<String,String> bindingMap) {
		try {
			BlockableContext myContext = (BlockableContext) blockableParticipant.getContext();
			Class<? extends BlockableContext> blockableContextClass = myContext.getClass();
			Method getSemaphoreMethod = BlockableContextMessages.getGetSemaphoreMethod(blockableContextClass, bindingMap);
			Semaphore mySemaphore = (Semaphore) getSemaphoreMethod.invoke(myContext, (Object[]) null);
			mySemaphore.acquireUninterruptibly();
			mySemaphore.release();
		} catch (Exception e) {
			// swallow
			e.printStackTrace();
		}
	}
	
	// helper methods for access to bound fields and methods
	// empty
}