package ca.mcgill.sel.aspectoptimaomtt.aspects.closable;

import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;

public interface ClosableParticipant extends CollaborativeParticipant {
	// public method signatures from structural view
	// empty
}

aspect ClosableParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @ClosableParticipantClass * implements ClosableParticipant;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	void around(ClosableParticipant target, ClosableContext c) : execution(void CollaborativeParticipant.joinContext(..)) && target(target) && args(c) {
		boolean closed = c.isClosed();
		if (!closed) {
			proceed(target, c);
		}
	}
}