package ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative;

import java.util.Set;
import java.util.HashSet;

import ca.mcgill.sel.aspectoptima.aspects.context.Context;

public interface CollaborativeContext extends Context {
	// public method signatures from structural view
	void addParticipant(CollaborativeParticipant participant);
	Set<CollaborativeParticipant> getParticipants();
	int getParticipantCount();
}

aspect CollaborativeContextAspect {
	// attributes & associations from structural view
	private Set<CollaborativeParticipant> CollaborativeContext.participants = new HashSet<CollaborativeParticipant>();
	
	// declared methods without message views
	public void CollaborativeContext.addParticipant(CollaborativeParticipant participant) {
		// auto-generated adder implementation
		this.participants.add(participant);
	}
	
	void around(CollaborativeContext target, CollaborativeParticipant participant) : execution(void Context.addParticipant(..))  && target(target) && args(participant) {
		// auto-generated overriding of existing adder
		target.addParticipant(participant);
	}
	
	void CollaborativeContext.removeParticipant(CollaborativeParticipant participant) {
		// auto-generated remover implementation
		this.participants.remove(participant);
	}
	
	void around(CollaborativeContext target, CollaborativeParticipant participant) : execution(void Context.removeParticipant(..))  && target(target) && args(participant) {
		// auto-generated overriding of existing remover
		target.participants.remove(participant);
	}
	
	public Set<CollaborativeParticipant> CollaborativeContext.getParticipants() {
		// auto-generated getter implementation
		return this.participants;
	}
	
	public int CollaborativeContext.getParticipantCount() {
		// auto-generated counter implementation
		return this.participants.size();
	}
	
	// methods shown in message views
	// empty
}