package ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative;

import ca.mcgill.sel.aspectoptima.aspects.context.Context;
import ca.mcgill.sel.aspectoptima.aspects.context.Participant;

public interface CollaborativeParticipant extends Participant {
	// public method signatures from structural view
	void joinContext(CollaborativeContext c);
}

aspect CollaborativeParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @CollaborativeParticipantClass * implements CollaborativeParticipant;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	public void CollaborativeParticipant.joinContext(CollaborativeContext c) {
		boolean allowed = this.isAllowedToJoin(c);
		if (allowed) {
			this.enterContext(c);
		}
	}
	
	private boolean CollaborativeParticipant.isAllowedToJoin(CollaborativeContext c) {
		boolean result;
		Context myContext = this.getContext();
		if (myContext == null) {
			result = true;
		}
		else {
			result = false;
		}
		return result;
	}
	
	void around(CollaborativeParticipant target) : execution(void Participant.leaveContext()) && target(target) {
		CollaborativeContext myContext = (CollaborativeContext) target.getContext();
		// BEGIN implementation refinement
		if (myContext != null) {
		// END implementation refinement
			myContext.removeParticipant(target);
			target.setContext(null);
		// BEGIN implementation refinement
		}
		// END implementation refinement
	}
}