package ca.mcgill.sel.aspectoptimaomtt.aspects.entrysynchronizing;

import ca.mcgill.sel.aspectoptimaomtt.aspects.blockable.BlockableParticipantForEntrySynchronizing;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;
import ca.mcgill.sel.aspectoptima.aspects.context.Participant;

public interface EntrySynchronizingParticipant extends CollaborativeParticipant, BlockableParticipantForEntrySynchronizing {
	// public method signatures from structural view
	// empty
}

aspect EntrySynchronizingParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @EntrySynchronizingParticipantClass * implements EntrySynchronizingParticipant;
	
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty
	
	// methods shown in message views
	after(EntrySynchronizingParticipant target, EntrySynchronizingContext c) : execution(void Participant.enterContext(..)) && target(target) && args(c) {
		EntrySynchronizingContext context = (EntrySynchronizingContext) target.getContext();
		if (context == c) {
			c.increaseWaitingParticipantCount();
			boolean last = c.isLastEnteringParticipant();
			if (last) {
				c.releaseEntrySemaphore();
			}
			else {
				target.waitForEntrySemaphore();
			}
			c.decreaseWaitingParticipantCount();
		}
	}
}