package ca.mcgill.sel.aspectoptimaomtt.aspects.exitsynchronizing;

import ca.mcgill.sel.aspectoptimaomtt.aspects.blockable.BlockableContextForExitSynchronizing;
import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeContext;

public interface ExitSynchronizingContext extends CollaborativeContext, BlockableContextForExitSynchronizing {
	// public method signatures from structural view
	// empty
}

aspect ExitSynchronizingContextAspect {
	// attributes & associations from structural view
	private int ExitSynchronizingContext.blockedParticipantCount = 0;
	
	// declared methods without message views
	private int ExitSynchronizingContext.getBlockedParticipantCount() {
		// auto-generated getter implementation
		return this.blockedParticipantCount;
	}
	
	void ExitSynchronizingContext.increaseBlockedParticipantCount() {
		// auto-generated incrementor implementation
		this.blockedParticipantCount++;
	}
	
	void ExitSynchronizingContext.decreaseBlockedParticipantCount() {
		// auto-generated decrementor implementation
		this.blockedParticipantCount--;
	}

	// methods shown in message views
	boolean ExitSynchronizingContext.isLastExitingParticipant() {
		boolean last = false;
		int blocked = this.getBlockedParticipantCount();
		int participants = this.getParticipantCount();
		if (blocked >= participants) {
			last = true;
		}
		return last;
	}
}