package ca.mcgill.sel.aspectoptimaomtt.aspects.openmultithreadedtransaction;

import java.util.concurrent.Callable;
import java.util.concurrent.Future;
import java.util.concurrent.FutureTask;

import org.aspectj.lang.annotation.AdviceName;

import ca.mcgill.sel.aspectoptima.aspects.transaction.Transactable;
import ca.mcgill.sel.aspectoptimaomtt.interfacing.AspectOPTIMAOMTT;
import ca.mcgill.sel.aspectoptimaomtt.interfacing.AspectOPTIMAOMTTInternal;
import ca.mcgill.sel.aspectoptimaomtt.interfacing.OMTTThread;

public interface OMTTransactable extends Transactable {
	// public method signatures from structural view
	// empty
}

aspect OMTTransactableAspect {
	// attributes & associations from structural view
	// empty
	
	// declared methods without message views
	// empty

	// methods shown in message views
	// empty
	// BEGIN implementation refinement
	/** surrounds every call to a open multithreaded transacted method with "begin" and "commit" 
	 * if they are not already called within an existing transaction */
	@AdviceName("transactMethod")
	Object around(final OMTTransactable target, final OMTTransactableMethod transactableMethodAnnotation): execution(* *.*(..)) && target(target) && @annotation(transactableMethodAnnotation) {
		OMTTParticipant participant = AspectOPTIMAOMTTInternal.getOMTTParticipant(transactableMethodAnnotation);
		boolean alreadyTransacted = participant.isAlreadyTransacted();
		if (!alreadyTransacted) {
			participant.beginTransaction();
		}
		Object returned = proceed(target, transactableMethodAnnotation);
		if (!alreadyTransacted) {
			participant.commitTransaction();
		}
		return returned;
	}
	// END implementation refinement
}