package ca.mcgill.sel.aspectoptimaomtt.aspects.pausable;

import ca.mcgill.sel.aspectoptimaomtt.aspects.collaborative.CollaborativeParticipant;
import ca.mcgill.sel.aspectoptimaomtt.aspects.blockable.BlockableParticipantForPausable;

public interface PausableParticipant extends CollaborativeParticipant, BlockableParticipantForPausable {
	// public method signatures from structural view
	void setPaused(boolean paused);
}

aspect PausableParticipantAspect {
	// bind annotations to mandatory instantiation parameter interfaces
	declare parents : @PausableParticipantClass * implements PausableParticipant;
	
	// attributes & associations from structural view
	private boolean PausableParticipant.paused = false;
	
	// declared methods without message views
	private boolean PausableParticipant.isPaused() {
		// auto-generated getter implementation
		return this.paused;
	}
	
	public void PausableParticipant.setPaused(boolean paused) {
		// auto-generated setter implementation
		this.paused = paused;
	}

	// methods shown in message views
	// empty
}