package ca.mcgill.sel.aspectoptimaomtt.example.travelagency;

import java.util.Arrays;
import java.util.Calendar;
import java.util.Calendar;
import java.util.List;

public class TravelRouter {
	public static List<Route> getRouteList(String departure, String destination, Calendar departureDate) {
		/* here we would use an existing service to split a route in multiple subroutes */
		if (departure.equals("Montreal") && destination.equals("Paris")) {
			Calendar d1 = (Calendar) departureDate.clone();
			d1.add(Calendar.HOUR, 9);
			Route r1 = new Route(departure, destination, Vehicle.PLANE, departureDate, d1);
			return Arrays.asList(new Route[] {r1});
		}
		if (departure.equals("Montreal") && destination.equals("New Delhi")) {
			Calendar d1 = (Calendar) departureDate.clone();
			d1.add(Calendar.HOUR, 3);
			Route r1 = new Route(departure, "NYC", Vehicle.PLANE, departureDate, d1);
			Calendar d2 = (Calendar) d1.clone();
			d2.add(Calendar.HOUR, 12);
			Route r2 = new Route("NYC", destination, Vehicle.PLANE, d1, d2);
			return Arrays.asList(new Route[] {r1, r2});
		}
		return null;
	}
}

class Route {
	String departure;
	String destination;
	Vehicle vehicleType;
	Calendar departureDate;
	Calendar arrivalDate;
	
	Route(String departure, String destination, Vehicle vehicleType,
			Calendar departureDate, Calendar arrivalDate) {
		this.departure = departure;
		this.destination = destination;
		this.vehicleType = vehicleType;
		this.departureDate = departureDate;
		this.arrivalDate = arrivalDate;
	}
	
	@Override
	public String toString() {
		return "From " + departure + " to " + destination;
	}
}

enum Vehicle {
	CAR,
	PLANE,
	TRAIN;
	
	boolean isCar() {
		return equals(Vehicle.CAR);
	}
	
	boolean isPlane() {
		return equals(Vehicle.PLANE);
	}
	
	boolean isTrain() {
		return equals(Vehicle.TRAIN);
	}
}