package ca.mcgill.sel.aspectoptimaomtt.test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotSame;

import org.junit.Test;

import ca.mcgill.sel.aspectoptima.test.AspectOPTIMATesting;

public class ExitSynchronizingTest {
	static final long timeToSleep = 10000;
	static final long timeToWait = timeToSleep + 1000;
	
	@Test
	public void test() { 
		try {
			AspectOPTIMAOMTTTesting.beginExitSynchronizing();
			Object c = AspectOPTIMAOMTTTesting.getActualContext();
			ExitSynchronizingRunnable r = new ExitSynchronizingRunnable(c);
			Thread t = new Thread(r);
			t.start();

			Thread.sleep(timeToWait);
			
			ExitSynchronizingRunnable r2 = new ExitSynchronizingRunnable(c);
			Thread t2 = new Thread(r2);
			t2.start();
			
			Thread.sleep(timeToWait);
			AspectOPTIMATesting.end();
			
			t.join();
			System.out.println("c " + c);
			assertNotSame(null, c);
			System.out.println("r.newContext " + r.newContext);
			assertEquals(c, r.newContext);
			System.out.println("AspectOPTIMAOMTTTesting.getActualParticipant() " + AspectOPTIMAOMTTTesting.getActualParticipant());
			System.out.println("r.newPartcipant " + r.newPartcipant);
			assertNotSame(AspectOPTIMAOMTTTesting.getActualParticipant(), r.newPartcipant);
			
			t2.join();
			System.out.println("c " + c);
			assertNotSame(null, c);
			System.out.println("r2.newContext " + r2.newContext);
			assertEquals(c, r2.newContext);
			System.out.println("AspectOPTIMAOMTTTesting.getActualParticipant() " + AspectOPTIMAOMTTTesting.getActualParticipant());
			System.out.println("r2.newPartcipant " + r2.newPartcipant);
			assertNotSame(AspectOPTIMAOMTTTesting.getActualParticipant(), r2.newPartcipant);
			
			long waiting = r.left - r.triedToLeave;
			System.out.println("waiting = r.left - r.triedToLeave " + waiting + " = " + r.left + " - " + r.triedToLeave);
			assertEquals(true, waiting > timeToWait - timeToSleep);
			
			long waiting2 = r2.left - r2.triedToLeave;
			System.out.println("waiting2 = r2.left - r2.triedToLeave " + waiting + " = " + r2.left + " - " + r2.triedToLeave);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}

class ExitSynchronizingRunnable implements Runnable {
	Object context;
	Object newContext;
	Object newPartcipant;
	long triedToLeave;
	long left;
	
	public ExitSynchronizingRunnable(Object context) {
		this.context = context;
	}

	@Override
	public void run() {
		AspectOPTIMAOMTTTesting.joinExitSynchronizing(context);
		newContext = AspectOPTIMAOMTTTesting.getActualContext();
		newPartcipant = AspectOPTIMAOMTTTesting.getActualParticipant();
		try {
			Thread.sleep(ExitSynchronizingTest.timeToSleep);
			triedToLeave = System.currentTimeMillis();
			AspectOPTIMATesting.end();
			left = System.currentTimeMillis();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
}